----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:26:18 04/29/2010 
-- Design Name: 
-- Module Name:    FSM_MASTER - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity FSM_MASTER is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           vld_in : in  STD_LOGIC;
           rst_s : out  STD_LOGIC;
           strt_s : out  STD_LOGIC;
			  ulock : in STD_LOGIC);
end FSM_MASTER;

architecture Behavioral of FSM_MASTER is

TYPE state is (rst_st,
					idle_st,
					lockl_st);

signal cur_st,nxt_st: state;

begin

process(clk)
begin
if (rst='1') then
	cur_st<= rst_st;
elsif (clk'event and clk='1') then
	cur_st <= nxt_st;
end if;
end process;

process(cur_st,vld_in,ulock)
begin 
case cur_st is

when rst_st =>

	rst_s<='1';	
	strt_s<='0';
			  
	nxt_st<=idle_st;
	
when idle_st =>

	rst_s<='0';	
	
	if vld_in='1' then
		strt_s<='1';
		nxt_st<=lockl_st;
	else
		strt_s<='0';
		nxt_st<=idle_st;
	end if;
	
when lockl_st =>

	rst_s<='0';	
	strt_s<='0';
	
	if ulock='1' then
		rst_s<='1';	
		nxt_st<=idle_st;
	else	
		nxt_st<=lockl_st;
	end if;

end case;
end process;


end Behavioral;

