----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:19:07 04/06/2010 
-- Design Name: 
-- Module Name:    EAU_ITER_TOP_c - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity EAU_ITER_TOP_c is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           valid_in : in  STD_LOGIC;
           value_in : in  STD_LOGIC_VECTOR (31 downto 0);
           valid_out : out  STD_LOGIC;
           vec_out : out  STD_LOGIC_VECTOR (11 downto 0);
           val_out : out  STD_LOGIC_VECTOR (31 downto 0));
end EAU_ITER_TOP_c;

architecture Behavioral of EAU_ITER_TOP_c is

component EAU_Iter_c is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           valid_in : in  STD_LOGIC;
           value_in : in  STD_LOGIC_VECTOR (24 downto 0);
           const_arg : in  STD_LOGIC_VECTOR (24 downto 0);
           valid_out : out  STD_LOGIC;
			  bit_out	: out STD_LOGIC;
           value_out : out  STD_LOGIC_VECTOR (24 downto 0));
end component;

constant const_val_iter1 : std_logic_Vector(24 downto 0):="0011111100000000000000000";--0.5
constant const_val_iter2 : std_logic_Vector(24 downto 0):="0011111010000000000000000";--0.25
constant const_val_iter3 : std_logic_Vector(24 downto 0):="0011111000000000000000000";--0.125
constant const_val_iter4 : std_logic_Vector(24 downto 0):="0011110110000000000000000";--0.0625
constant const_val_iter5 : std_logic_Vector(24 downto 0):="0011110100000000000000000";--0.03125
constant const_val_iter6 : std_logic_Vector(24 downto 0):="0011110010000000000000000";--0.015625
constant const_val_iter7 : std_logic_Vector(24 downto 0):="0011110000000000000000000";--0.0078125
constant const_val_iter8 : std_logic_Vector(24 downto 0):="0011101110000000000000000";--0.00390625
constant const_val_iter9 : std_logic_Vector(24 downto 0):="0011101100000000000000000";--0.001953125
constant const_val_iter10 : std_logic_Vector(24 downto 0):="0011101010000000000000000";--0.0009765625
constant const_val_iter11 : std_logic_Vector(24 downto 0):="0011101000000000000000000";--0.00048828125
constant const_val_iter12 : std_logic_Vector(24 downto 0):="0011100110000000000000000";--0.000244140625



signal iter1_vld_out,
		 iter2_vld_out,
		 iter3_vld_out,
		 iter4_vld_out,
		 iter5_vld_out,
		 iter6_vld_out,
		 iter7_vld_out,
		 iter8_vld_out,
		 iter9_vld_out,
		 iter10_vld_out,
		 iter11_vld_out,
		 iter12_vld_out: std_logic;

signal iter1_bit,
		 iter2_bit,
		 iter3_bit,
		 iter4_bit,
		 iter5_bit,
		 iter6_bit,
		 iter7_bit,
		 iter8_bit,
		 iter9_bit,
		 iter10_bit,
		 iter11_bit,
		 iter12_bit:	std_logic;

signal iter1_val_out,
		 iter2_val_out,
		 iter3_val_out,
		 iter4_val_out,
		 iter5_val_out,
		 iter6_val_out,
		 iter7_val_out,
		 iter8_val_out,
		 iter9_val_out,
		 iter10_val_out,
		 iter11_val_out,
		 iter12_val_out: std_logic_vector(24 downto 0);

component shift_reg_1b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 0 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 0 downto 0 ) 
  );
end component;

component shift_reg_2b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 1 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 1 downto 0 ) 
  );
end component;

component shift_reg_3b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 2 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 2 downto 0 ) 
  );
end component;

component shift_reg_4b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 3 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 3 downto 0 ) 
  );
end component;

component shift_reg_5b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 4 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 4 downto 0 ) 
  );
end component;

component shift_reg_6b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 5 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 5 downto 0 ) 
  );
end component;

component shift_reg_7b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 6 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 6 downto 0 ) 
  );
end component;

component shift_reg_8b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 7 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 7 downto 0 ) 
  );
end component;

component shift_reg_9b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 8 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 8 downto 0 ) 
  );
end component;

component shift_reg_10b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 9 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 9 downto 0 ) 
  );
end component;

component shift_reg_11b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 10 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 10 downto 0 ) 
  );
end component;

signal shft1_vec_in,shft1_vec_out : std_logic_vector(0 downto 0);
signal shft2_vec_in,shft2_vec_out : std_logic_vector(1 downto 0);
signal shft3_vec_in,shft3_vec_out : std_logic_vector(2 downto 0);
signal shft4_vec_in,shft4_vec_out : std_logic_vector(3 downto 0);
signal shft5_vec_in,shft5_vec_out : std_logic_vector(4 downto 0);
signal shft6_vec_in,shft6_vec_out : std_logic_vector(5 downto 0);
signal shft7_vec_in,shft7_vec_out : std_logic_vector(6 downto 0);
signal shft8_vec_in,shft8_vec_out : std_logic_vector(7 downto 0);
signal shft9_vec_in,shft9_vec_out : std_logic_vector(8 downto 0);
signal shft10_vec_in,shft10_vec_out : std_logic_vector(9 downto 0);
signal shft11_vec_in,shft11_vec_out : std_logic_vector(10 downto 0);


begin

ITERATION1: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => valid_in,
  value_in => value_in(31 downto 7),
  const_arg => const_val_iter1,
  valid_out => iter1_vld_out,
  bit_out	=> iter1_bit, -- this is the MSB
  value_out => iter1_val_out
);

shft1_vec_in(0)<=iter1_bit;
SHIFT1: shift_reg_1b_11c Port Map (
    clk => clk,
    d => shft1_vec_in, 
    q => shft1_vec_out 
  );

ITERATION2: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter1_vld_out,
  value_in => iter1_val_out,
  const_arg => const_val_iter2,
  valid_out => iter2_vld_out,
  bit_out	=> iter2_bit,
  value_out => iter2_val_out
);

shft2_vec_in(0)<=iter2_bit;
shft2_vec_in(1)<=shft1_vec_out(0);
SHIFT2: shift_reg_2b_11c Port Map (
    clk => clk,
    d => shft2_vec_in, 
    q => shft2_vec_out 
  );

ITERATION3: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter2_vld_out,
  value_in => iter2_val_out,
  const_arg => const_val_iter3,
  valid_out => iter3_vld_out,
  bit_out	=> iter3_bit,
  value_out => iter3_val_out
);

shft3_vec_in(0)<=iter3_bit;
shft3_vec_in(2 downto 1)<=shft2_vec_out(1 downto 0);
SHIFT3: shift_reg_3b_11c Port Map (
    clk => clk,
    d => shft3_vec_in, 
    q => shft3_vec_out 
  );

ITERATION4: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter3_vld_out,
  value_in => iter3_val_out,
  const_arg => const_val_iter4,
  valid_out => iter4_vld_out,
  bit_out	=> iter4_bit,
  value_out => iter4_val_out
);



shft4_vec_in(0)<=iter4_bit;
shft4_vec_in(3 downto 1)<=shft3_vec_out(2 downto 0);
SHIFT4: shift_reg_4b_11c Port Map (
    clk => clk,
    d => shft4_vec_in, 
    q => shft4_vec_out 
  );

ITERATION5: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter4_vld_out,
  value_in => iter4_val_out,
  const_arg => const_val_iter5,
  valid_out => iter5_vld_out,
  bit_out	=> iter5_bit,
  value_out => iter5_val_out
);

shft5_vec_in(0)<=iter5_bit;
shft5_vec_in(4 downto 1)<=shft4_vec_out(3 downto 0);
SHIFT5: shift_reg_5b_11c Port Map (
    clk => clk,
    d => shft5_vec_in, 
    q => shft5_vec_out 
  );

ITERATION6: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter5_vld_out,
  value_in => iter5_val_out,
  const_arg => const_val_iter6,
  valid_out => iter6_vld_out,
  bit_out	=> iter6_bit,
  value_out => iter6_val_out
);


shft6_vec_in(0)<=iter6_bit;
shft6_vec_in(5 downto 1)<=shft5_vec_out(4 downto 0);
SHIFT6: shift_reg_6b_11c Port Map (
    clk => clk,
    d => shft6_vec_in, 
    q => shft6_vec_out 
  );

ITERATION7: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter6_vld_out,
  value_in => iter6_val_out,
  const_arg => const_val_iter7,
  valid_out => iter7_vld_out,
  bit_out	=> iter7_bit,
  value_out => iter7_val_out
);



shft7_vec_in(0)<=iter7_bit;
shft7_vec_in(6 downto 1)<=shft6_vec_out(5 downto 0);
SHIFT7: shift_reg_7b_11c Port Map (
    clk => clk,
    d => shft7_vec_in, 
    q => shft7_vec_out 
  );

ITERATION8: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter7_vld_out,
  value_in => iter7_val_out,
  const_arg => const_val_iter8,
  valid_out => iter8_vld_out,
  bit_out	=> iter8_bit,
  value_out => iter8_val_out
);


shft8_vec_in(0)<=iter8_bit;
shft8_vec_in(7 downto 1)<=shft7_vec_out(6 downto 0);
SHIFT8: shift_reg_8b_11c Port Map (
    clk => clk,
    d => shft8_vec_in, 
    q => shft8_vec_out 
  );

ITERATION9: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter8_vld_out,
  value_in => iter8_val_out,
  const_arg => const_val_iter9,
  valid_out => iter9_vld_out,
  bit_out	=> iter9_bit,
  value_out => iter9_val_out
);


shft9_vec_in(0)<=iter9_bit;
shft9_vec_in(8 downto 1)<=shft8_vec_out(7 downto 0);
SHIFT9: shift_reg_9b_11c Port Map (
    clk => clk,
    d => shft9_vec_in, 
    q => shft9_vec_out 
  );

ITERATION10: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter9_vld_out,
  value_in => iter9_val_out,
  const_arg => const_val_iter10,
  valid_out => iter10_vld_out,
  bit_out	=> iter10_bit,
  value_out => iter10_val_out
);

shft10_vec_in(0)<=iter10_bit;
shft10_vec_in(9 downto 1)<=shft9_vec_out(8 downto 0);
SHIFT10: shift_reg_10b_11c Port Map (
    clk => clk,
    d => shft10_vec_in, 
    q => shft10_vec_out 
  );

ITERATION11: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter10_vld_out,
  value_in => iter10_val_out,
  const_arg => const_val_iter11,
  valid_out => iter11_vld_out,
  bit_out	=> iter11_bit,
  value_out => iter11_val_out
);


shft11_vec_in(0)<=iter11_bit;
shft11_vec_in(10 downto 1)<=shft10_vec_out(9 downto 0);
SHIFT11: shift_reg_11b_11c Port Map (
    clk => clk,
    d => shft11_vec_in, 
    q => shft11_vec_out 
  );

ITERATION12: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter11_vld_out,
  value_in => iter11_val_out,
  const_arg => const_val_iter12,
  valid_out => iter12_vld_out,
  bit_out	=> iter12_bit,
  value_out => iter12_val_out
);


vec_out(11 downto 1)<=shft11_vec_out;
vec_out(0)<=iter12_bit;

valid_out<=iter12_vld_out;
val_out(31 downto 7)<=iter12_val_out;
val_out(6 downto 0)<="0000000";

end Behavioral;

